SystemOrganization addCategory: #'Ma object serialization tester-SUnit tests'!

!ByteArray methodsFor: '*ma object serialization tester' stamp: 'cmm 11/23/2004 21:17'!
maEquivalentForSerializationTest: aByteArray using: anIdentityKeyDictionary halt: aBoolean
	self == aByteArray ifTrue: [ ^ true ].
	aByteArray class = self class ifFalse: [ ^ false ].
	^ self = aByteArray! !

!Set methodsFor: '*ma object serialization tester' stamp: 'cmm 11/23/2004 15:15'!
maEquivalentForSerializationTest: anObject using: alreadyComparedDictionary halt: aBoolean

	self == anObject ifTrue: [^ true].	"stop recursion"
	(anObject class = Set) ifFalse: [^ false].
	self size = anObject size ifFalse: [^ false].
	self do:
		[ : each | 
		(anObject anySatisfy: 
			[ : eachInOther |
			(each
				maEquivalentForSerializationTest: eachInOther
				using: IdentityDictionary new
				halt: false) ]) ifFalse: [ aBoolean ifTrue: [ self halt ].  ^ false ] ].
	^ true! !

!HandMorph methodsFor: '*ma object serialization tester' stamp: 'cmm 11/24/2004 10:54'!
maEquivalentForSerializationTest: aHandMorph using: anIdentityKeyDictionary halt: aBoolean
	^ self == ActiveHand! !

!Object methodsFor: '*ma object serialization tester' stamp: 'cmm 11/23/2004 14:11'!
maEquivalentForSerializationTest: anObject
	"(sigh)  Floats and streams need their own equivalence checking."
	^ self
		maEquivalentForSerializationTest: anObject 
		using: IdentityDictionary new
		halt: true! !

!Object methodsFor: '*ma object serialization tester' stamp: 'cmm 11/23/2004 21:18'!
maEquivalentForSerializationTest: anObject using: alreadyComparedDictionary halt: shouldHalt
	| answer identityCheck |
	self == anObject ifTrue: [ ^ true ].
	self class = anObject class ifFalse: [ ^ false ].
	identityCheck _ false.  "purpose of this is for debugging, when halt is on you know where it went."
	^ (1 to: self maInstSize) allSatisfy:
		[ : x |  | myX otherX |
		myX _ self instVarAt: x.
		otherX _ anObject instVarAt: x.
		answer _
			(alreadyComparedDictionary includesKey: myX)
				ifTrue: [ identityCheck _ true. (alreadyComparedDictionary at: myX) = otherX ]
				ifFalse:
					[ myX ifNotNil: [ alreadyComparedDictionary at: myX put: otherX ].
					myX 
						maEquivalentForSerializationTest: otherX
						using: alreadyComparedDictionary
						halt: shouldHalt ].
		(shouldHalt and: [ answer == false ]) ifTrue: [ self halt ] ifFalse: [ answer ] ]! !

!Float methodsFor: '*ma object serialization tester' stamp: 'cmm 11/23/2004 15:09'!
maEquivalentForSerializationTest: aFloat using: anIdentityKeyDictionary halt: aBoolean
	aFloat isFloat ifFalse: [ ^ false ].
	^ self asIEEE32BitWord = aFloat asIEEE32BitWord ! !

!UndefinedObject methodsFor: '*ma object serialization tester' stamp: 'cmm 11/23/2004 14:16'!
maEquivalentForSerializationTest: anObject using: alreadyComparedDictionary halt: aBoolean
	^ anObject == nil! !

!Dictionary methodsFor: '*ma object serialization tester' stamp: 'cmm 11/23/2004 22:05'!
maAtSerializationEquivalent: anObject

	self keysDo:
		[ : eachKey |
		(anObject
			maEquivalentForSerializationTest: eachKey
			using: IdentityDictionary new
			halt: false) ifTrue: [ ^ eachKey ] ].
	^ nil! !

!Dictionary methodsFor: '*ma object serialization tester' stamp: 'cmm 11/23/2004 22:09'!
maEquivalentForSerializationTest: anObject using: alreadyComparedDictionary halt: aBoolean
	self == anObject ifTrue: [ ^ true ].
	(anObject class = self class) ifFalse: [^false].
	self size = anObject size ifFalse: [^false].
	self keysDo:
		[ : eachMyKey |  | correspondingOtherKey |
		"first, find equivalent key in other Dictionary, unfortunately we can't use at:."
		correspondingOtherKey _ anObject maAtSerializationEquivalent: eachMyKey.
		correspondingOtherKey ifNotNil:
			[ ((self at: eachMyKey)
				maEquivalentForSerializationTest: (anObject at: correspondingOtherKey)
				using: alreadyComparedDictionary
				halt: aBoolean)

				ifFalse: [ aBoolean ifTrue: [ self halt ] ifFalse: [ ^ false ] ] ] ].
	^ true! !

MaTestCase subclass: #MaObjectSerializerTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization tester-SUnit tests'!

!MaObjectSerializerTestCase methodsFor: 'as yet unclassified' stamp: 'cmm 12/1/2004 16:50'!
testSamples

	| newSamples |
	newSamples _ MaFixtureFactory current samples.
	newSamples keysAndValuesDo:
		[ : eachSelector : eachSamples |
		self should:
			[ | sample |
			sample _ eachSamples anyOne.
			(MaObjectSerializer testMaterialize: sample) maEquivalentForSerializationTest: sample ].
		self should:
			[ (MaObjectSerializer testMaterialize: eachSamples) maEquivalentForSerializationTest: eachSamples ] ].
	"Now test the whole thing as one big object."
	(MaObjectSerializer testMaterialize: newSamples) keysAndValuesDo:
		[ : eachSelector : eachSamples |
		eachSamples with: (newSamples at: eachSelector) do:
			[ : eachMaterialized : eachNew |
			self should: [ eachMaterialized maEquivalentForSerializationTest: eachNew ] ] ].
	! !

!Boolean methodsFor: '*ma object serialization tester' stamp: 'cmm 11/23/2004 14:16'!
maEquivalentForSerializationTest: aBoolean using: anIdentityKeyDictionary halt: shouldHalt
	^ self == aBoolean! !

!BlockContext methodsFor: '*ma object serialization tester' stamp: 'cmm 11/23/2004 21:16'!
maEquivalentForSerializationTest: aBlockContext using: anIdentityKeyDictionary halt: aBoolean

	self == aBlockContext ifTrue: [ ^ true ].
	aBlockContext class = self class ifFalse: [ ^ false ].
	^ self method = aBlockContext method
	and: [ self numArgs = aBlockContext numArgs
	and: [ self startpc = aBlockContext startpc ] ]! !

!Symbol methodsFor: '*ma object serialization tester' stamp: 'cmm 12/1/2004 16:39'!
maEquivalentForSerializationTest: aSymbol using: alreadyComparedDictionary halt: aBoolean
	aSymbol isSymbol ifFalse: [ ^ false ].
	^ self == aSymbol! !

!WriteStream methodsFor: '*ma object serialization tester' stamp: 'cmm 11/23/2004 21:18'!
maEquivalentForSerializationTest: aWriteStream using: alreadyComparedDictionary halt: aBoolean
	self == aWriteStream ifTrue: [ ^ true ].
	aWriteStream class = self class ifFalse: [ ^ false ].
	self size = aWriteStream size ifFalse: [ ^ false ].
	^ self contents = aWriteStream contents! !

!ReadStream methodsFor: '*ma object serialization tester' stamp: 'cmm 11/23/2004 21:18'!
maEquivalentForSerializationTest: aReadStream using: alreadyComparedDictionary halt: aBoolean
	self == aReadStream ifTrue: [ ^ true ].
	aReadStream class = self class ifFalse: [ ^ false ].
	self size = aReadStream size ifFalse: [ ^ false ].
	^ self contents = aReadStream contents! !

!String methodsFor: '*ma object serialization tester' stamp: 'cmm 11/23/2004 15:15'!
maEquivalentForSerializationTest: aString using: alreadyComparedDictionary halt: aBoolean
	aString isString ifFalse: [ ^ false ].
	^ self = aString! !

!ProcessorScheduler methodsFor: '*ma object serialization tester' stamp: 'cmm 11/24/2004 10:53'!
maEquivalentForSerializationTest: aProcessorScheduler using: anIdentityKeyDictionary halt: aBoolean
	^ aProcessorScheduler == Processor! !

!SystemDictionary methodsFor: '*ma object serialization tester' stamp: 'cmm 11/24/2004 10:54'!
maEquivalentForSerializationTest: aSystemDictionary using: anIdentityKeyDictionary halt: aBoolean
	^ Smalltalk == aSystemDictionary! !

!Behavior methodsFor: '*ma object serialization tester' stamp: 'cmm 11/23/2004 21:20'!
maEquivalentForSerializationTest: anObject using: alreadyComparedDictionary halt: shouldHalt

	^ self == anObject! !

MaSingleton subclass: #MaFixtureFactory
	instanceVariableNames: 'allNonCollectionSamples'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization tester-SUnit tests'!

!MaFixtureFactory class methodsFor: 'initializing' stamp: 'cmm 2/2/2003 14:30'!
initialize

	self reset! !

!MaFixtureFactory methodsFor: 'private accessing' stamp: 'cmm 6/17/2002 22:42'!
allCollectionSamplesHoldingNonCollections

	^(self methodsInCategory: 'private collection samples')
		inject: OrderedCollection new
		into:
			[ :coll :each |
			coll
				addAll: (self perform: each selector);
				yourself ]
! !

!MaFixtureFactory methodsFor: 'private accessing' stamp: 'cmm 9/13/2004 00:29'!
allNonCollectionSamples

	allNonCollectionSamples
		ifNil:
			[ allNonCollectionSamples _ OrderedCollection new.
			self nonCollectionSamplesDo:
				[ : eachSelector : eachSamples |
				allNonCollectionSamples addAll: eachSamples ] ].
	^ allNonCollectionSamples! !

!MaFixtureFactory methodsFor: 'private collection samples' stamp: 'cmm 6/17/2002 22:42'!
arraySamples

	| populatedArray |

	populatedArray _ self allNonCollectionSamples asArray.
	^Array
		with: Array new
		with: (Array new: 100)
		with: populatedArray
! !

!MaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 6/17/2002 22:43'!
atomicSamples

	^Array
		with: nil
		with: true
		with: false
! !

!MaFixtureFactory methodsFor: 'private collection samples' stamp: 'cmm 10/18/2004 21:29'!
bagSamples

	^Array
		with: Bag new
		with: (Bag new addAll: (self allNonCollectionSamples copyWithout: nil); yourself) ;
		with: (Bag new add: 'a small bag' withOccurrences: 9999999999; yourself)! !

!MaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 11/12/2004 16:30'!
blockSamples

	^ { [ self class name = #MaFixtureFactory ifFalse: [ self error: 'Block home not correct' ] ].
	[ : each | Transcript cr; show: each printString ].
	[ : a : b | a name > b name ] }! !

!MaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 6/17/2002 22:43'!
byteArraySamples

	^Array
		with: ByteArray new
		with: (ByteArray new: 100)
		with: (0 to: 255) asByteArray
! !

!MaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 7/11/2002 00:23'!
characterSamples

	^Character allCharacters! !

!MaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 10/28/2004 22:26'!
classSamples

	^ Collection withAllSubclasses asArray! !

!MaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 11/12/2004 16:18'!
compiledMethodSamples

	^ Array
		with: Object>>#size
		with: OrderedCollection>>#add:
		with: MagmaSession>>#disconnect! !

!MaFixtureFactory methodsFor: 'private collection samples' stamp: 'cmm 7/8/2002 21:42'!
dictionarySamples

	| populatedDictionary |

	populatedDictionary _ Dictionary new.
	(self allNonCollectionSamples copyWithout: nil) do:
		[ :each |
		populatedDictionary
			at: each
			put: populatedDictionary copy ].
	^Array
		with: Dictionary new
		with: populatedDictionary
! !

!MaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 11/26/2004 13:17'!
exceptionSamples
	^ { Error new messageText: 'sample error'.
	Warning new messageText: 'sample warning'.
	Notification new messageText: 'sample notification' }! !

!MaFixtureFactory methodsFor: 'private accessing' stamp: 'cmm 7/28/2002 10:40'!
firstNames

	^#('Paula' 'Chris' 'Bif' 'Yury' 'David' 'Russ' 'Judy')! !

!MaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 9/14/2004 12:48'!
floatSamples

	^{ Float e.  Float halfPi.  Float infinity.  "Float nan. <- this one is not supported, see http://lists.squeakfoundation.org/pipermail/squeak-dev/2004-September/082071.html"  Float negativeZero.  Float pi.  101.10001 }! !

!MaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 7/11/2002 00:03'!
fractionSamples

	^Array with: 3/4 with: 0-(1001/1000)! !

!MaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 11/25/2004 21:35'!
globalSamples

	^{ Transcript. Processor. Smalltalk. ActiveHand. Integer.  Integer class }! !

!MaFixtureFactory methodsFor: 'private collection samples' stamp: 'cmm 10/18/2004 21:21'!
intervalSamples

	^ Array
		with: (1 to: 10)
		with: (-30 to: 130 by: 2)
		with: (1 to: 999999999)
		with: (10 to: -6 by: -2)! !

!MaFixtureFactory methodsFor: 'creation' stamp: 'cmm 6/23/2002 21:35'!
knot
	"Answer an object that contains a graph of references that span every combination of class supported by Magma."

	| samples populatedDictionary |

	samples _ OrderedCollection new.
	"First build collections that support addAll:"
	#(OrderedCollection Set Bag) do:
		[ :eachClassName |
		samples add: (
			(Smalltalk classNamed: eachClassName) new
				addAll: self allCollectionSamplesHoldingNonCollections;
				yourself) ].
	"Now do Array and Dictionary"
	samples add: self allCollectionSamplesHoldingNonCollections asArray.
	populatedDictionary _ Dictionary new.
	self allCollectionSamplesHoldingNonCollections do:
		[ :each |
		populatedDictionary
			at: each
			put: populatedDictionary copy ].
	samples add: populatedDictionary.
	^samples
! !

!MaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 6/17/2002 22:43'!
largeIntegerSamples

	^Array
		with: 100 factorial
		with: (0-100 factorial)
! !

!MaFixtureFactory methodsFor: 'private accessing' stamp: 'cmm 7/28/2002 10:41'!
lastNames

	^#('Mayer' 'Muller' 'Brower' 'Katsman' 'Jackson' 'Blade' 'Muller')! !

!MaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 10/28/2004 22:26'!
metaClassSamples

	^ self classSamples collect: [ : each | each class ]! !

!MaFixtureFactory methodsFor: 'private accessing' stamp: 'cmm 6/17/2002 22:42'!
methodsInCategory: aString

	^MaMethodSelector new
		addClass: self class;
		selectCategories: (Array with: aString);
		methods
! !

!MaFixtureFactory methodsFor: 'private accessing' stamp: 'cmm 7/28/2002 10:45'!
middleNames

	^#('Leslie' 'Michael' '' '' '' '' 'Ann')! !

!MaFixtureFactory methodsFor: 'creation' stamp: 'cmm 7/28/2002 10:41'!
newMailingAddresses: anInteger

	^(1 to: anInteger) collect:
		[ :index |
		MagmaMailingAddress new
			street: (self streetNames at: index);
			zip: (self zipCodes at: index);
			yourself ]! !

!MaFixtureFactory methodsFor: 'accessing' stamp: 'cmm 7/28/2002 10:43'!
newOrganizationMailingAddresses: anInteger

	^(5 to: 5 + anInteger - 1) collect:
		[ :index |
		MagmaMailingAddress new
			street: (self streetNames at: index);
			zip: (self zipCodes at: index);
			yourself ]! !

!MaFixtureFactory methodsFor: 'creation' stamp: 'cmm 7/28/2002 10:41'!
newPersonNames: anInteger

	^(1 to: anInteger) collect:
		[ :index |
		MagmaPersonName new
			first: (self firstNames at: index);
			middle: (self middleNames at: index);
			last: (self lastNames at: index);
			yourself ]! !

!MaFixtureFactory methodsFor: 'creation' stamp: 'cmm 9/1/2003 15:15'!
newPersons: anInteger
	"Answer a collection of anInteger number of MagmaPerson's."

	| names addresses persons |

	persons _ OrderedCollection new: anInteger.
	names _ self newPersonNames: anInteger.
	addresses _ self newMailingAddresses: anInteger.
	names
		with: addresses
		do:
			[ :eachName :eachAddress |
			persons add: (
				(Smalltalk classNamed: #MagmaPerson) new
					name: eachName;
					address: eachAddress) ].
	^persons! !

!MaFixtureFactory methodsFor: 'private individual fixtures' stamp: 'cmm 6/17/2002 22:43'!
noArgComplexBlock

	^[ | c |
		c _ OrderedCollection new.
		MaObject withAllSubclasses do: [ :each | c add: each name asLowercase ].
		c ]
! !

!MaFixtureFactory methodsFor: 'private creation - domain objects' stamp: 'cmm 12/26/2004 16:10'!
nonCollectionSamplesDo: twoArgBlock

	(self methodsInCategory: 'private non-collection samples') do:
		[ : each |
		twoArgBlock
			value: each methodSymbol
			value: (self perform: each methodSymbol) ]! !

!MaFixtureFactory methodsFor: 'private individual fixtures' stamp: 'cmm 6/17/2002 22:43'!
oneArgComplexBlock

	^[ :number | number sqrt ]
! !

!MaFixtureFactory methodsFor: 'private collection samples' stamp: 'cmm 7/8/2002 21:43'!
orderedCollectionSamples

	^Array
		with: OrderedCollection new
		with: (OrderedCollection new addAll: self allNonCollectionSamples; yourself)
! !

!MaFixtureFactory methodsFor: 'private accessing' stamp: 'cmm 8/8/2002 23:35'!
organizationNames

	^#(
		'Magmanet'
		'Muller Automation')! !

!MaFixtureFactory methodsFor: 'creation' stamp: 'cmm 8/8/2002 17:17'!
peopleSample

	^self newPersons: 3! !

!MaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 11/26/2004 09:32'!
processSamples
	^ { [ MaObject withAllSubclasses asArray reverse collect: [ : ea | ea printString ] ] newProcess }! !

!MaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 6/17/2002 22:43'!
readStreamSamples

	^Array
		with: (ReadStream on: (1 to: 1000));
		with: (ReadStream on: #('chris' 'paula'))
! !

!MaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 6/17/2002 22:43'!
readWriteStreamSamples

	^Array
		with: (ReadWriteStream on: (1 to: 1000));
		with: (ReadWriteStream on: #('chris' 'paula'))
! !

!MaFixtureFactory methodsFor: 'creation' stamp: 'cmm 9/13/2004 00:12'!
samples
	| samples |

	samples _ Dictionary new.
	self nonCollectionSamplesDo:
		[ : eachSelector : eachSamples |
		samples
			at: eachSelector
			put: eachSamples ].
	^ samples! !

!MaFixtureFactory methodsFor: 'private collection samples' stamp: 'cmm 7/8/2002 21:43'!
setSamples

	^Array
		with: Set new
		with: (Set new addAll: (self allNonCollectionSamples copyWithout: nil); yourself)
! !

!MaFixtureFactory methodsFor: 'private individual fixtures' stamp: 'cmm 6/17/2002 22:43'!
simpleBlock

	^[ 'hello' collect: [ :each | each asUppercase ] ]
! !

!MaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 6/17/2002 22:43'!
smallIntegerSamples

	^Array
		with: -1212
		with: -7
		with: 0
		with: 1111
! !

!MaFixtureFactory methodsFor: 'private collection samples' stamp: 'cmm 11/12/2004 16:16'!
sortedCollectionSamples

	| sentence |
	sentence _ 'the quick brown fox slyly jumped over 1029384756 lazy dogs.'.
	^Array
		with: SortedCollection new
		with: sentence asSortedCollection
		with: (
			(SortedCollection sortBlock: [ :a :b | a > b ])
				addAll: sentence substrings;
				addAll: sentence asUppercase substrings;
				yourself)
! !

!MaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 11/20/2004 12:06'!
soundSamples

	^ { PluckedSound default.
	Speaker default }! !

!MaFixtureFactory methodsFor: 'private accessing' stamp: 'cmm 7/28/2002 10:43'!
streetNames

	^#(
		'7547 McGee'
		'1314 E. 82nd Terr. #15'
		'4421 Springfield'
		'101 W. Meyer'
		'281 Aisle Drive'
		'2138 E. 83rd Terr.'
		'2104 E. Gregory')! !

!MaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 6/17/2002 22:43'!
stringSamples

	| allCharactersString |

	allCharactersString _ (0 to: 255) asByteArray asString.
	^Array
		with: String new
		with: 'hello'
		with: allCharactersString
! !

!MaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 7/8/2002 21:07'!
symbolSamples

	^Array
		with: #size
		with: #with:with:with:with:
		with: #'hello there'
		"with: '' asSymbol  <- conflicts with empty String sample since, in Squeak, they're equal.."
! !

!MaFixtureFactory methodsFor: 'private individual fixtures' stamp: 'cmm 12/25/2002 00:47'!
threeArgComplexBlock

	^[ :path :parent :index |
		Transcript
			cr;
			tab: path size;
			nextPutAll: path last printString ]
! !

!MaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 11/7/2004 23:41'!
uuidSamples

	^ { UUID fromString: 'a3b64357-377a-5b41-b575-1c653084a121'.
	UUID nilUUID }! !

!MaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 6/17/2002 22:43'!
writeStreamSamples

	^Array
		with: (WriteStream on: String new);
		with: (WriteStream on: (OrderedCollection new: 200))
! !

!MaFixtureFactory methodsFor: 'private creation - domain objects' stamp: 'cmm 7/28/2002 10:45'!
zipCodes

	^#(
		'64114'
		'64131'
		'66101'
		'10201'
		'98876'
		'12345'
		'71717')! !

!TranscriptStream methodsFor: '*ma object serialization tester' stamp: 'cmm 11/24/2004 10:52'!
maEquivalentForSerializationTest: aTranscriptStream using: anIdentityKeyDictionary halt: aBoolean
	^ aTranscriptStream == Transcript! !
MaFixtureFactory initialize!
